/**********************************************

       Testing database functionalitys

       br anvndas i valid_parameter

**********************************************/

:-module( dbase, [ findAlbums/2,
		   findArtistsSong/2,
		   findArtistsAlbum/2,
		   findSongsArtist/2,
		   song_list/1,
		   song_list2/1,
		   song_by_artist/3,
		   group_in_db/1,
		   album_in_db/1,
		   station_in_db/1,
		   make_name/2,
		   break_list/2] ).

:- use_module( library(lists), [member/2,
				append/3] ).


%%% default_path( -DefaultPathToMusicLibrary )
%%default_path( '/home/andreas/music/' ).
default_path( 'C:\\Musik\\test\\music\\' ).

%%% findAlbum( +Artist, -AlbumsAtom )
findAlbums( Artist, Albums ):-
	(
	  setof(Album, NotUsed^Not2^post(Artist,Album,NotUsed,Not2), AlbumList ), %% albums == list of lists
	  findall(Album2, (post(best_of,Album2,List),member(_Song-Artist,List) ), AlbList2Tmp),
	  sort(AlbList2Tmp,AlbumList2)
	->
	  nice_atom(AlbumList,Albs1),
	  nice_atom(AlbumList2,Albs2),
	  (
	    Albs2 = ''
	  ->
	    Albums = Albs1
	  ;
	    concat_atom(Albs1,',',TmpAlbs),
	    concat_atom(TmpAlbs,Albs2,Albums)
	  )
	;
	  setof(Album2, (post(best_of,Album2,List),member(_Song-Artist,List) ), AlbumList2),
	  nice_atom(AlbumList2,Albums)
	;
	  Albums = ''
	).

%%% findArtistsSong( +Song, -ArtistsAtom )
findArtistsSong( Song, Artists ):-
	(
	  setof(Artist, (post(Artist,_,SongList,_),member(Song,SongList)), ArtistList ),
	  findall(Artist2, (post(best_of,_Album,List),member(Song-Artist2,List) ), ArtistList2Tmp),
	  sort(ArtistList2Tmp,ArtistList2)
	  ->
	  nice_atom(ArtistList,Arts1),
	  nice_atom(ArtistList2,Arts2),	  
	  (
	    Arts2 = ''
	  ->
	    Artists = Arts1
	  ;
	    concat_atom(Arts1,',',TmpArts),
	    concat_atom(TmpArts,Arts2,Artists)
	  )
	;
	  setof(Artist3, (post(best_of,_Album2,List),member(Song-Artist3,List) ), ArtistList3),
	  nice_atom(ArtistList3,Artists)
	;
	  Artists = ''
	).

%%% findArtistsAlbum( +Album, -ArtistsAtom )
findArtistsAlbum( Album, Artists ):-
	(
	  setof(Artist, N^NN^post(Artist,Album,N,NN), ArtistList )
	->
	  nice_atom(ArtistList,Artists)
	;
	  post(best_of,Album,_List),
	  Artists = best_of
	)
	;
	Artists = ''.

findSongsArtist( Artist, Songs ):-
	(
	  setof(Song, Not^N2^post(Artist,Not,Song,N2), SongList),
	  findall(Song2, (post(best_of,_Not,List),member(Song2-Artist,List) ), SongList2Tmp),
	  sort(SongList2Tmp,SongList2)
	->
	  nice_song_atom(SongList,Songs1),
	  nice_atom(SongList2,Songs2),
	  %% if Songs2 == ''
	  (
	    Songs2 = ''
	  ->
	    Songs = Songs1
	  ;
	      concat_atom(Songs1,',',TmpSongs),
	      concat_atom(TmpSongs,Songs2,Songs)
	  ),
	  !
	;
	  setof(Song2, (post(best_of,Not,List),member(Song2-Artist,List) ), SongList2),
	  nice_atom(SongList2,Songs),
	  !
	;
	  Songs = ''
	).

%%% findSongsArtist( Artist, Songs ):-
%%% 	(
%%% 	  setof(Song, Not^N2^post(Artist,Not,Song,N2), SongList)
%%% 	->
%%% 	  nice_song_atom(SongList,Songs),
%%% 	  !
%%% 	;
%%% 	  Songs = ''
%%% 	).

song_list( List ):-
	post(_,_,List,_).

song_list2( List ):-
	post(_,_,List).

%%% song_by_artist( +Song, +Artist, -Path )
song_by_artist(Song,Artist,Path):-
	(
	  post(Artist,_,SongList,_),
	  member(Song,SongList)
	;
	  post(best_of,_Album,List),
	  member(Song-Artist,List)
	),
	default_path(Path).

group_in_db( Group ):-
	post(Group,_,_,_).

album_in_db( Album ):-
	post(_,Album,_,_)
	;
	post(_,Album,_).

station_in_db( Station ):-
	post(Station,_)
	;
	post(_,Station).


%%% post( ?Artist, ?Album, ?SongList, ?Genre )
%%% the arguments will be lists of lists
%%% the local file names are like: people_are_strange.mp3

%%% actual songs on local disk
post( [covenant],         [sequencer],                 [ [stalker],[leviathan],[edge,of,dawn],[tension] ],          _genre ).
post( [depeche,mode],     [violator],                  [ [world,in,my,eyes],[halo],[policy,of,truth] ],             _genre ).
post( [flesh,field],      [viral,extinction],          [ [fallen,angel],[silicon,skies],[where,angels,go,to,die] ], _genre ).
post( [komputer],         [valentia],                  [ [valentina] ],                                             _genre ).
post( [madonna],          [the,immaculate,collection], [ [justify,my,love],[lucky,star],[open,your,heart] ], _genre ).
post( [mesh],             [in,this,place,forever],     [ [you,didnt,want,me],[trust,you] ],                  _genre ).
post( [morrissey],        [bona,drag],                 [ [november,spawned,a,monster],[suedehead] ],         _genre ).
post( [nitzer,ebb],       [that,total,age],            [ [warsaw,ghetto],[murderous],[let,beauty,loose] ],   _genre ).
post( [peps,persson],     [peps,bitar],                 [ [hg,standard],[frmmande],[hll,ut] ],             _genre ).
post( [pet,shop,boys],    [please],                    [ [west,end,girls],[love,comes,quickly] ],            _genre ).
post( [spock],            [single],                    [ [romulan,ale] ],                                    _genre ).

%%% songs that will be added to local disc soon...
post( [dia,psalma],       [gryningstid],               [ [alla,lskar,dig],[hon,fr],[tro,rtt,tro,fel],[den,som,spar],
							 [emelie],[kalla,sinnen],[grytfot],[gryningsvisa,i,d,moll],
							 [sol,ver,oss] ],  _genre ).

post( [ebba,grn],        [1978,1982],                 [ [profit],[ung,och,snkt],[tyst,fr,fan],[mona,tumbas,slim,club],
							 [vad,skall,du,bli],[hng,gud],[totalvgra],[bevpna,er],
							 [det,mste,vara,radion],[pervers,politiker],[staten,och,kapitalet],
							 [ung,och,kt],[ttahundra,grader],[mamma,pappa,barn],[mental,istid],
							 [flyktsoda],[uppgng,och,fall],[tittar,p,tv],
							 [nu,slcks,tusen,mnniskoliv] ],  _genre ).

post( [jumper],           [jumper],                    [ [tapetklister],[den,vgen],[i,vrt,kvarter],[nr,hela,vrlden,str,utanfr],
							 [ngot,som,hon,saknar],[p,andra,sidan,molnen],[kom,som,en,man],
							 [tro,att,du,vet],[vgskl],[jag,undrar] ],  _genre ).

post( [nordman],          [nordman],                   [ [vandraren],[under,norrskenet],[nnu,glder,solen],[vill,ha,mer],
							 [s,syns,du,inte,mer],[frlist],[laglst,land],[och,regnet,fll],
							 [nu,lever,sommaren],[stormens,ga],[om,hon,vill,det,sjlv],
							 [strmkarlen],[locklt],[i,midsommartid] ],         _genre ).

post( [nordman],          [ingenmansland],             [ [det,sista,du,ser],[be,mig],[p,mossen],[i,nattens,sista,timma],
							 [se,mig,idag],[brudrovet],[vem,kan,slcka,elden],[fly,i,ro],
							 [som,livet,och,dden],[fick,jag,leva,igen],[frmlingen] ], _genre ).

post( [nordman],          [hr,och,nu],                [ [kalla,mig,dre],[hjlp,mig,att,leva],[sorg,min,lskarinna],
							 [se,dig,sjlv],[det,var,inte,hr],[barockpolska],[hstlven,dansar,idag],
							 [kom,nu,gubbar],[i,det,bl],[strmt],[300,r],[det,r,ditt,verk] ], _genre ).

%% har lt med samma namn som album
post( [roger,pontare],   [i,vargens,spr],             [ [flykting],[sanningens,krigare],[berg,av,is],[nr,vindarna,viskar,ditt,namn],
							 [hvdingens,bn],[siaren],[i,vargens,spr],[vid,bergens,rand],
							 [norden,befolkas],[hr,mitt,ord] ],  _genre ).

post( [roger,pontare],   [julens,snger],              [ [nu,tndas,tusen,juleljus],[ett,barn,r,ftt,p,denna,dag],
							 [fransk,julvisa],[den,signade,dag],[stilla,natt] ],  _genre ).

post( [viba,femba],      [alla,talar,svenska],         [ [sm,mnniskor],[bejaka],[det,knns,igen],[litet,bo,vill,jag,stta],
							 [puss],[amors,pilar],[en,bit,lk],[herman,gr],[slttervisa],
							 [en,mnskensnatt,p,slottsbacken],[glimmande,nymf] ],  _genre ).


%%% specialpost fr samlingsalbum...
%%% post( ?X, ?Title, ?ListWithSong-Group)
post( best_of, [topp,hits],         [ [se,p,mig]-[jan,johansen],
				      [det,vackraste]-[cecilia,vennersten],
				      [dina,frger,var,bl]-[tommy,nilsson],
				      [tess]-[peter,lemarc],
				      [vad,du,ser,r,vad,du,fr]-[lisa,nilsson],
				      [gr,ut,med,mig,sjlv]-[mauro,scocco],
				      [nr,vgarna,lockar]-[malin,julia] ] ).


post( best_of, [svenska,klassiker], [ [flickorna,p,tv,tv]-[gyllene,tider],
				      [solglasgon]-[docent,dd],
				      [ttahundra,grader]-[ebba,grn],
				      [flickan,och,krkan]-[mikael,wiehe],
				      [diamanter]-[lustans,lakejer],
				      [blinkar,bl]-[adolphson,och,falk],
				      [sommaren,r,kort]-[tomas,ledin],
				      [en,del,av,mitt,hjrta]-[tomas,ledin],
				      [ppna,landskap]-[ulf,lundell],
				      [segla,p,ett,moln]-[annelie,ryde],
				      [vintersaga]-[monica,trnell],
				      [du,ska,va,president]-[imperiet],
				      [vindarna]-[freda],
				      [under,ytan]-[uno,svenningsson],
				      [jag,blir,hellre,jagad,av,vargar]-[orup],
				      [efter,stormen]-[marie,fredrisson],
				      [hll,om,mig]-[peter,lemarc],
				      [vem,ska,jag,tro,p]-[di,leva],
				      [krlekens,tunga]-[eldkvarn],
				      [vingar]-[mikael,rickfors],
				      [vara,vnner]-[jakob,hellman],
				      [ngeln,i,rummet]-[eva,dahlgren],
				      [vem,tnder,stjrnorna]-[eva,dahlgren],
				      [det,hon,vill,ha]-[christer,sandelin] ] ).

				    
%%% post( ?RadioStation, ?IP-no/address )
post( [digital,gunfire], 'http://129.16.159.166:8000' ).
post( [rant,radio],      'http://130.240.207.88:9090' ).
post( [chat,radio],      'http://chatradio.myftp.org:10010' ).


%%% From a list of lists with album names to an atom
%%% of all albums
%%%
%%% nice_atom( +AlbumList, -AlbumsAtom ).
nice_atom( [], '' ).
nice_atom( [AlbumNameList|Xs], AlbumsAtom ):-
	make_name(AlbumNameList,TempAtom),
	nice_atom(Xs,Temp2Atom),
	(
	  Temp2Atom = ''
	->
	  AlbumsAtom = TempAtom
	;
	  concat_atom(TempAtom,',',T2),
	  concat_atom(T2,Temp2Atom,AlbumsAtom)
	).


%%% only for seeking songs
%[[[stalker],[feedback],[figurehead]]]
nice_song_atom( [NiceAtom], SongsAtom ):- 
	nice_atom(NiceAtom,SongsAtom).
%%% om lista med listor av listor
%%% artist har gjort flera album
nice_song_atom( [SongList|Rest], SongsAtom ):-
	nice_song_atom([SongList],Tmp),
	nice_song_atom(Rest,Tmp2),
	concat_atom(Tmp,',',T),
	concat_atom(T,Tmp2,SongsAtom).

make_name(List,Atom):-
	make_name(List,[],Atom),
	!.
make_name([],_,'').
make_name([Last],_,Atom):-
	concat_atom('',Last,Atom).
make_name([First|Rest],Temp,Atom):-
	make_name(Rest,Temp,A2),
	concat_atom(First,'_',Atom2),
	concat_atom(Atom2,A2,Atom).


%%% From ONE long list with all albums to a broken
%%% down list of lists with album names
%%%
%%% CharList == list of charCodes from the atom
%%% AlbumList == list of albumnames
break_list(CharList,AlbumList):-
	break_list(CharList,[],AlbumList),
	!.

break_list([],X,X).
break_list(CharList,Temp,AlbumList):-
	kom([X]),
	append(FirstList,[X|Rest],CharList),
	name(FirstAtom,FirstList),
	atom2list(FirstAtom,FirstAtomList),
	append([FirstAtomList],Temp,T2),
	break_list(Rest,T2,AlbumList).

break_list(CharList,Temp,AlbumList):-
	name(CharAtom,CharList),
	atom2list(CharAtom,CharAtomList),
	append(Temp,[CharAtomList],AlbumList).

atom2list(Atom,AtomList):-
	atom2list(Atom,[],AtomList),
	!.

atom2list('',AtomList,AtomList).
atom2list(Atom,TempList,AtomList):-
	name(Atom,A_list),
%	append(FirstList,[32|Rest],A_list),
	append(FirstList,[95|Rest],A_list),%% 95 == _
	name(First,FirstList),
	append(TempList,[First],T2),
	name(Second,Rest),
	atom2list(Second,T2,AtomList).
atom2list(Atom,TempList,AtomList):-
	append(TempList,[Atom],AtomList).

chk_albs( [] ).
chk_albs( [Album|Xs] ):-
	album(Album),
	chk_albs(Xs).

kom(X):-
	name(',',X).

%%% instead of atom_concat
concat_atom( PsAtom1, PsAtom2, Atom):-
	name(PsAtom1,X),
	atom_chars(A1,X),
	name(PsAtom2,X2),
	atom_chars(A2,X2),
	atom_concat(A1,A2,Atom).